Subject: Re: [RFC/PATCH 4/4] Add support for MSI on Axon-based Cell systems

From: Jean-Christophe Dubois <[email-masked]>
Date: Thu, 7 Jun 2007 10:10:04 +0200

On Thursday 07 June 2007 09:58:59 Michael Ellerman wrote:
> On Tue, 2007-06-05 at 09:00 +0200, Jean-Christophe Dubois wrote:
> > On Monday 04 June 2007 15:00:05 Michael Ellerman wrote:
> > > +       pr_debug("axon_msi: initialising ...\n");
> > > +
> > > +       for_each_compatible_node(node, NULL, "ibm,axon-msic") {
> > > +               if (axon_msi_setup_one(of_node_get(node)) == 0)
> > > +                       found++;
> > > +       }
> > > +       of_node_put(node);
> >
> > 2 comments:
> >
> > 1) There is no "ibm,axon-msic" compatible property in the SLOF tree
> > provided by IBM on the CAB (or other such platforms). Therefore this code
> > will not work on these platforms.
>
> It's not clear to me if MSIs will work on CAB, with Axon in end-point
> mode. But it'd be good to try it at some point.

The CAB (or other derived products) can be set in RC mode (via a jumper). In 
this case the MSI could be supported.

> The compatible property is new, it's only just been added to SLOF
> recently by Heiko, not sure when it will be in released firmware.
>
> > 2) you should somehow check for the Axon version. Axon 1.1 (and prior)
> > are know to be loosing MSI/MBX interrupts (but not the data part
> > associated to them). Therefore this should be enabled only on Axon 2.1
> > (or later).
>
> Yep. It works some of the time on 1.1, but not enough to enable it.
>
> I guess I'd say firmware that runs on 1.1 should just not export the msi
> nodes, or not put the compatible property on them - rather than having
> the kernel explicitly checking for the version.
>
> cheers